% remove jumps to jumps
% remove nop from delayed slot

(compiletime (progn (load useful) (on fast-integers)))
 
(fluid '(*ConditionalJumps* *unconditionalJumps* *goodjumps* 
         *nonMovables* *alljumps* *lapopt))
 
(setq *goodjumps* '( BR!.N BCND!.N BR!.N BB0!.N BB1!.N))

(setq *unconditionalJumps* '(JSR!.N JMP!.N BR!.N))

(setq *nonMovables* (append *goodjumps!* '(
 MOVE-RELOCATABLE-OBJECT MOVE-RELOCATABLE-OBJECT-and-load
 MOVE-RELOCATABLE-OBJECT-and-store nop *entry jsr!.n jmp jmp!.n jsr)))

(setq *alljumps* (append *goodjumps!* *unconditionalJumps*))

(compiletime (ds NOPp (x) ((lambda(h) (and (pairp h)(eq (car h) 'NOP))) x)))

(de LapOptReformJumps (code)
  (let (rcode rrcode inst inst2 x y z cond jump inv lab lastinst delayslot)
       (when (NOT *LAPOPT) (return code)) % Main switch
%        % first phase% change (any (without reg))
%			       (ld (reg) 
%                              (any (using reg))
% into (ld ..) (any ..) (any ..)

      (while code
	 (setq inst (pop code))
	 (when (and (pairp inst) rcode (pairp (setq lastinst (car rcode)))
		(eqcar lastinst 'ld) (member (cadr lastinst) (operands inst))
		(cdr rcode) (pairp (setq inst2 (cadr rcode)))
		(not (member (cadr lastinst) (operands inst2)))
		(or (atom (cdr inst2))
		    (not (member (cadr inst2) (operands lastinst))))
		% target of first instr must not be needed for second
		(not (and (eqcar inst2 'st)
		          (equal (cddr inst2) (cddr lastinst))))
		% no intermix of ld and st of same object
		(not (member (car inst2) *nonMovables*)))
		(setq x (pop rcode)) (setq y (pop rcode))
		(push x rcode) (push y rcode))
	(push inst rcode))

      (setq code (reversip rcode)) (setq rcode nil)
        % second phase: look for jumps to jumps and for negation jumps
      (return code)
  ))


(de operands (x)	 %simplified form , only looking for regs
   % extract the operands from x
   (cond ((atom x) nil)
         ((member x '((reg zero))) nil)
	 ((or (memq (car x) '(reg))) (list x))
         ((memq (car x) '(scaled displacement label wconst indexed indirect))
          (operands (cdr x)))
         (t (nconc (operands (car x)) (operands (cdr x))))))


