%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PV:SYS-SUPPORT.SL
% Description:  CONVEX-specific kernel support functions
% Author:       
% Created:      
% Modified:       
% Mode:         Lisp
% Package:      
% Status:       Experimental (Do Not Distribute)
%
%               Changes to All functions by W. Neun, ZIB Berlin, Nov-15-88
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% changes in   Symfnc jumps:                     W. Neun
%     CALLER:                   SYMFNC Vect         CALLEE
%       Call  SYMFNC+4*id  -->  BA   target   ->    
%                               SETHI idnumber,%o0   in delay slot
%
%   Note : the callee gets the idnumber shifted by ten bits in i0/o0
%
%       This allows to use normal calling sequence (instead of two calls)
%       (it also limits the code space to 8Mbyte, hope that does not matter)

(on fast-integers)

(lap '((*entry addressapply0 expr 0)
       (*move (reg 1) (reg a1))
       (jmp (indexed (reg a1) 0)) ))


(de bittable (baseaddress bitoffset)
  (field (ilsh (byte baseaddress (ilsh bitoffset -2))
               (idifference (itimes2 (field bitoffset 30 2) 2) 6))
         30 2))


(lap '((!*entry PlantUnbound expr 1)
       (ld!.w (entry UndefinedFunction) (reg 2))
       (*move (reg 1)(reg a1))
       (*wshift (reg a1) 2)              % ID*4
       (*move (fluid SYMFNC) (reg a2))
       (!*WPLUS2 (reg a1) (reg a2))
       (*move (reg 2) (indexed (reg a1) 0))
       (!*EXIT 0)
       ))

(lap '((!*entry PlantCodePointer expr 2)
       (*move (reg 1)(reg a1)) 
       (*wshift (reg a1) 2)              % ID*4
       (*move (fluid SYMFNC) (reg a2))   
       (!*WPLUS2 (reg a1) (reg a2))  
       (*move (reg 2) (indexed (reg a1) 0))
       (!*EXIT 0)  
       ))

(lap '((!*entry PlantLambdaLink expr 1)
       (ld!.w (entry CompiledCallingInterpreted) (reg 2))
       (*move (reg 1)(reg a1))
       (*wshift (reg a1) 2)              % ID*4
       (*move (fluid SYMFNC) (reg a2))   
       (!*WPLUS2 (reg a1) (reg a2))  
       (*move (reg 2) (indexed (reg a1) 0))
       (!*EXIT 0)  
       ))

(lap '((*entry CompiledCallingInterpreted expr 0)
       (jmp! !@ (entry CompiledCallingInterpreted-1))))

(lap '((*entry undefinedfunction expr 0)
       (*move (reg s7) (reg 1))
       (*mkitem (reg 1) (wconst id-tag))
       (*Jcall undefinedfunctionaux)))

(de undefinedfunctionaux(x)
      (console-print-string "Undefined function called: ")
      (console-print-string (symnam (inf x)))
      (console-newline))

(de kernel-fatal-error (message)
  (console-print-string "FATAL ERROR:") 
  (console-print-string message)
  (console-newline)
  (exit-to-caller -1)
  )

(de exit-to-caller (sta)
   (external_exit sta))


