
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         sun4-nk-spec.sl
% Title:        misc functions for sparc nonkernel
% Author:       Winfried Neun
% Created:      27 February 1989
% Status:       Experimental
% Mode:         Lisp
% Package:      Kernel
%
% (c) Copyright 1989, Konrad-Zuse-Zentrum Berlin, all rights reserved.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(compiletime
  (flag '(halfwordsequal vectorequal wordsequal intern-equal
          bothzero floateqn pairequal fast-wordsequal )
                   'internalfunction))

(lap '((*entry fast-clear  expr 2) % this is for SUN4 only
   %
   % clearing unrooled loop
   %
   % parm 1: source            (will be inf'ed)
   % parm 2: length

      (*alloc 0)
      (andn (reg 1) (reg i5) (reg 1))
      (and (reg 2) 15 (reg 5))   % the remainder mod 16
      (*wshift (reg 2) -4)            % length / 16
      (*move 0 (reg 4))
      (*jumpwleq (label exitlupe) (reg 2) 0)
  lupe
      (*move (reg 4)   (indexed (reg 1) 0))
      (*move (reg 4)   (indexed (reg 1) 8))
      (*move (reg 4)   (indexed (reg 1) 16))
      (*move (reg 4)   (indexed (reg 1) 24))
      (*move (reg 4)   (indexed (reg 1) 32))
      (*move (reg 4)   (indexed (reg 1) 40))
      (*move (reg 4)   (indexed (reg 1) 48))
      (*move (reg 4)   (indexed (reg 1) 56))
      (*move (reg 4)   (indexed (reg 1) 64))
      (*move (reg 4)   (indexed (reg 1) 72))
      (*move (reg 4)   (indexed (reg 1) 80))
      (*move (reg 4)   (indexed (reg 1) 88))
      (*move (reg 4)   (indexed (reg 1) 96))
      (*move (reg 4)   (indexed (reg 1) 104))
      (*move (reg 4)   (indexed (reg 1) 112))
      (*move (reg 4)   (indexed (reg 1) 120))
      (*wplus2 (reg 2) -1)
      (*wplus2 (reg 1) 128)
      (*jumpwgreaterp (label lupe) (reg 2) 0)
   exitlupe
      (*move 15 (reg 4))
      (*wdifference (reg 4) (reg 5))  % 15 -rem (lng,16)
      (*wshift (reg 4) 2)             % * 2 (4 bytes)
      (move-relocatable-object "Hugo" (reg 5))
      (jmpl (displacement (reg 5) (reg 4)) (reg 0))
      (*move 0 (reg 2))
    "Hugo"
      (*move (reg 2) (indexed (reg 1) 112))
      (*move (reg 2) (indexed (reg 1) 104))
      (*move (reg 2) (indexed (reg 1) 96))
      (*move (reg 2) (indexed (reg 1) 88))
      (*move (reg 2) (indexed (reg 1) 80))
      (*move (reg 2) (indexed (reg 1) 72))
      (*move (reg 2) (indexed (reg 1) 64))
      (*move (reg 2) (indexed (reg 1) 56))
      (*move (reg 2) (indexed (reg 1) 48))
      (*move (reg 2) (indexed (reg 1) 40))
      (*move (reg 2) (indexed (reg 1) 32))
      (*move (reg 2) (indexed (reg 1) 24))
      (*move (reg 2) (indexed (reg 1) 16))
      (*move (reg 2) (indexed (reg 1)  8))
      (*move (reg 2) (indexed (reg 1)  0))
      (*exit 0)))
 
(remd 'eqn)

(de eqn (u v)
  % Eq or numeric equality.
      (case (tag u)
        ((posint-tag)   (or (weq u v) (and (eq 0 u) (bothzero u v))))
        ((negint-tag)   (weq u v))
        ((floatnum-tag) (floateqn u v))
        ((fixnum-tag)
                (and (fixnp v) (weq (fixval (fixinf u)) (fixval (fixinf v)))))
        ((bignum-tag)   (and (bigp v) (wordsequal u v)))
        (nil (eq u v))))

(de floateqn (u v)
      (or (and (floatp v)
               (weq (floathighorder (fltinf u)) (floathighorder (fltinf v)))
               (weq (floatloworder (fltinf u))  (floatloworder (fltinf v))))
          (bothzero u v)))

(de bothzero (u v) (and (zerop u) (zerop v)))

(remd 'evlis)

(de evlis(u)
      (prog (result pointer)
           (when (not (pairp u)) (return nil))
           (setq pointer (setq result (cons (eval (car u)) nil)))
       loop
           (setq u (cdr u))
           (when (not (pairp u)) (return result))
           (rplacd pointer (cons (eval (car u)) nil))
           (setq pointer (cdr pointer))
           (go loop)))

(mapobl 
  (function 
    (lambda (id)
	(when (get id 'type) 
	 (if (wgetv SYMGET (idinf id))
		(wputv (inf (wgetv SYMGET (idinf id))) 1 (get id 'type))
		 (wputv SYMGET (idinf id) (mkvect &symgetsize&))
		 (wputv (inf (wgetv SYMGET (idinf id))) 1 (get id 'type)) )))))
