%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:           PU:IF-SYSTEM.SL
% Description:    Conditional compilation for system-dependent code
% Author:         Eric Benson
% Created:        10 March 1982
% Modified:       05-Sep-84 11:11:18 (Brian Beach)
% Mode:           Lisp
% Package:        Utilities
% Status:         Experimental
% Runtime:        PL:SYS-CONSTS.B
%
% (c) Copyright 1983, Hewlett-Packard Company, all rights reserved.
% Copyright (c) 1982 University of Utah
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
% 26-Jun-84 14:43:47 (Jim Ambras/CRC)
%  Added load of sys-consts (for system_list* value).
% 02-Dec-83 18:06:19 (Nancy Kendzierski)
%   Translated from Rlisp to Lisp.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(load sys-consts)

(fluid '(system_list!*))

(dm if_system (u)
  (do_if_system (cadr u) (caddr u) (if (cdddr u)
                  (cadddr u)
                  nil)))

(de do_if_system (system_name true_case false_case)
  (if (memq system_name system_list!*)
    true_case
    false_case))

